export const dialogChange = {
  mounted(el: any, binding: any, vnode: any) {
    setTimeout(() => {
      // 自定义属性，判断是否可拉伸
      if (!binding.value) return
      const dragDom: any = document.querySelector('.can-resize')
      console.log('dragDom:', dragDom)

      const dragDomBody: any = dragDom.querySelector('.el-dialog__body')
      dragDomBody.style.overflow = 'auto'
      const minHeight = 300
      const minWidth = 400
      // 右下角设置一个图标点击拖拽缩放大小（注意：此处mouse需要与代码中的类名一致，否则会报错）
      const dragMouse: any = document.querySelector('.mouse')
      // 鼠标拖拽
      dragMouse.onmousedown = (e: any) => {
        // content区域
        const content = dragDom.parentNode.parentNode
        const disX = e.clientX - dragDom.offsetWidth
        const disY = e.clientY - dragDom.offsetHeight

        document.onmousemove = function (e) {
          e.preventDefault() // 移动时禁用默认事件
          // 通过事件委托，计算移动的距离e
          let width = e.clientX - disX
          let height = e.clientY - disY

          if (width > content.offsetWidth && height < content.offsetHeight) {
            if (height < minHeight) {
              height = minHeight
            }
            dragDom.style.height = `${height}px`
            // 减去头部高度
            dragDomBody.style.maxHeight = `${height - 60}px`
          } else if (width < content.offsetWidth && height > content.offsetHeight) {
            if (width < minWidth) {
              width = minWidth
            }
            dragDom.style.width = `${width}px`
          } else if (width < content.offsetWidth && height < content.offsetHeight) {
            if (height < minHeight) {
              height = minHeight
            }
            if (width < minWidth) {
              width = minWidth
            }
            dragDom.style.width = `${width}px`
            dragDom.style.height = `${height}px`
            // 减去头部高度
            dragDomBody.style.maxHeight = `${height - 60}px`
          }
        }
        document.onmouseup = function (e) {
          document.onmousemove = null
          document.onmouseup = null
        }
        return false
      }
    }, 50)
  },
}
